#Demo pro studenty na nejjednoduchsi ovladani Source Measurement Unit Keithley 2450
import visa
import time
rm = visa.ResourceManager()
res = open("VISAresources.txt",'w')
print ("vypis VISA kompatibilnich portu:", rm.list_resources(), file=res)

keithley = rm.open_resource("USB0::0x05E6::0x2450::04039713::INSTR")  #definice objektu keithley s USB adresou 
print(keithley.query("*IDN?"))	# mozno testovat, jestli je dobra odezva



keithley.write("CURR:RSEN ON") # nastav ctyrkontaktni mereni proudu
keithley.write("VOLT:RSEN ON") # nastav ctyrkontaktni mereni napeti
#keithley.write(":SENSe:AZERo:ONCE") # proved korekci na nulu
#keithley.write(":SENSe:CURR:AZERo ON") # proved korekci proudu na nulu
#keithley.write(":SENSe:VOLT:AZERo ON") # proved korekci napeti na nulu
keithley.write(":SENSe:CURRent:NPLCycles 1") # Nastav presnost, NPLC 0.01 - 10
Imax=input("Zadej maximalni proud v A bezpecny pro soucastku: ")
Imax=float(Imax)
keithley.write(":SOUR:VOLT:ILIMIT "+str(Imax)) # nastav limit proudu,

keithley.write(":SOUR:VOLT 0.3")  #  nastav napeti 0.7V
keithley.write(":OUTP ON") # prived napeti na obvod
time.sleep(50e-3)  		#pocka (sekund)  na ustabilizovani proudu
#
print ("proud je:", keithley.query("MEAS:CURR?")) # precti proud
time.sleep(50e-3)  #musi byt prodleva pro cteni pred vypnutim proudu 
keithley.write(":OUTP OFF") # Vypni proud z pristroje -  bezpecnost pro soucastky

